Loading...
Searching...
No Matches
BaseGraphComponent Class Reference

## Detailed Description

This class describes the base interface of undirected graph types. All graph concepts have to conform to this class. It extends the interface of BaseDigraphComponent with an `Edge` type and functions to get the end nodes of edges, to convert from arcs to edges and to get both direction of edges.

`#include <lemon/concepts/graph_components.h>`

Inheritance diagram for BaseGraphComponent:
[legend]

## Classes

class | Edge
| Undirected edge class of the graph. More...

## Public Member Functions

Node | u (const Edge &) const
| Return one end node of an edge.
Node | v (const Edge &) const
| Return the other end node of an edge.
Arc | direct (const Edge &, bool) const
| Return a directed arc related to an edge.
Arc | direct (const Edge &, const Node &) const
| Return a directed arc related to an edge.
bool | direction (const Arc &) const
| Return the direction of the arc.
Arc | oppositeArc (const Arc &) const
| Return the opposite arc.
Public Member Functions inherited from BaseDigraphComponent
Node | source (const Arc &) const
| Return the source node of an arc.
Node | target (const Arc &) const
| Return the target node of an arc.
Node | oppositeNode (const Node &, const Arc &) const
| Return the opposite node on the given arc.

## Additional Inherited Members

Public Types inherited from BaseDigraphComponent
typedef GraphItem< 'n'> | Node
| Node class of the digraph.
typedef GraphItem< 'a'> | Arc
| Arc class of the digraph.

## Member Function Documentation

## u()

Node u | ( | const Edge & |  | ) | const

inline

This function returns one end node of an edge.

## v()

Node v | ( | const Edge & |  | ) | const

inline

This function returns the other end node of an edge.

## direct() [1/2]

Arc direct | ( | const Edge & | ,
|  | bool | ) const

inline

This function returns a directed arc from its direction and the represented edge.

## direct() [2/2]

Arc direct | ( | const Edge & | ,
|  | const Node & | ) const

inline

This function returns a directed arc from its source node and the represented edge.

## direction()

bool direction | ( | const Arc & |  | ) | const

inline

Returns the direction of the arc. Each arc represents an edge with a direction. It gives back the direction.

## oppositeArc()

Arc oppositeArc | ( | const Arc & |  | ) | const

inline

This function returns the opposite arc, i.e. the arc representing the same edge and has opposite direction.